use rust_decimal::Decimal;

pub enum Gene {
    GeneInt(i128),
    GeneFloat(Decimal),
    GeneString(Vec<char>),
    GeneBool(bool),
    GeneChar(char),
    GeneVectorInt(Vec<i128>),
    GeneVectorFloat(Vec<Decimal>),
    GeneVectorString(Vec<Vec<char>>),
    GeneVectorBool(Vec<bool>),
    GeneVectorChar(Vec<char>),
    // StateFunc(TODO)
    Close,
    Open(u8),
    Skip,
    Block(Vec<Gene>),
}

pub struct PushState {
    pub int: Vec<i128>,
    pub float: Vec<Decimal>,
    pub string: Vec<Vec<char>>,
    pub bool: Vec<bool>,
    pub char: Vec<char>,
    pub vector_int: Vec<Vec<i128>>,
    pub vector_float: Vec<Vec<Decimal>>,
    pub vector_string: Vec<Vec<Vec<char>>>,
    pub vector_bool: Vec<Vec<bool>>,
    pub vector_char: Vec<Vec<char>>,
    pub code: Vec<Gene>,
    pub exec: Vec<Gene>,
}

pub const EMPTY_STATE: PushState = PushState {
    int: vec![],
    float: vec![],
    string: vec![],
    bool: vec![],
    char: vec![],
    vector_int: vec![],
    vector_float: vec![],
    vector_string: vec![],
    vector_bool: vec![],
    vector_char: vec![],
    exec: vec![],
    code: vec![],
};
